SystemOrganization addCategory: #'PetitGui-Core'!

!PPChoiceParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/9/2009 14:24'!
exampleOn: aStream
	parsers atRandom exampleOn: aStream! !

!PPChoiceParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/7/2009 15:09'!
morphicShapeSeen: aSet depth: anInteger
	| morph |
	^ (anInteger < 1 or: [ aSet includes: self ])
		ifTrue: [ super morphicShapeSeen: aSet depth: anInteger ]
		ifFalse: [
			aSet add: self.
			morph := RectangleMorph new.
			morph 
				borderWidth: 0;
				color: Color transparent;
				layoutPolicy: TableLayout new;
				cellPositioning: #leftCenter;
				listDirection: #topToBottom;
				hResizing: #shrinkWrap;
				vResizing: #spaceFill;
				layoutInset: 5;
				cellInset: 5.
			self children
				do: [ :each | morph addMorphBack: (each morphicShapeSeen: aSet depth: anInteger - 1) ].
			morph ]! !

!PPAndParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/9/2009 14:44'!
exampleOn: aStream! !

!PPAndParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/9/2009 14:43'!
morphicShapeSeen: aSet depth: anInteger
	aSet add: self.
	^ parser morphicShapeSeen: aSet depth: anInteger! !

!PPEpsilonParser methodsFor: '*petitgui-mondrian' stamp: 'lr 11/6/2009 18:42'!
displayName
	^ 'epsilon'! !

!PPLiteralParser methodsFor: '*petitgui-mondrian' stamp: 'lr 11/7/2009 13:31'!
displayName
	^ literal asString! !

!PPLiteralSequenceParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/9/2009 14:25'!
exampleOn: aStream
	aStream nextPutAll: literal! !

!PPParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/6/2009 18:31'!
displayColor
	^ self isUnresolved
		ifTrue: [ Color red ]
		ifFalse: [ 
			self isNullable
				ifTrue: [ Color blue ]
				ifFalse: [ Color black ] ]! !

!PPParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/6/2009 18:31'!
displayName
	^ self name isNil
		ifFalse: [ self name asString ]
		ifTrue: [ self class name asString ]! !

!PPParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/9/2009 14:37'!
example
	^ String streamContents: [ :stream | self exampleOn: stream ] limitedTo: 1024! !

!PPParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/9/2009 14:20'!
exampleOn: aStream! !

!PPParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/7/2009 14:55'!
morphicShape
	^ self morphicShapeSeen: IdentitySet new depth: 2! !

!PPParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/7/2009 13:25'!
morphicShapeSeen: aSet depth: anInteger
	^ TextMorph new
		centered;
		autoFit: true;
		borderWidth: 1;	
		borderColor: Color black;
		backgroundColor: Color white;
		textColor: (self isTerminal
			ifTrue: [ Color purple ]
			ifFalse: [ Color blue ]);
		contents: self displayName;
		yourself! !

!PPSequenceParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/9/2009 14:24'!
exampleOn: aStream
	parsers do: [ :each | each exampleOn: aStream ]! !

!PPSequenceParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/7/2009 15:11'!
morphicShapeSeen: aSet depth: anInteger
	| morph |
	^ (anInteger < 1 or: [ aSet includes: self ])
		ifTrue: [ super morphicShapeSeen: aSet depth: anInteger ]
		ifFalse: [
			aSet add: self.
			morph := RectangleMorph new.
			morph 
				borderWidth: 0;
				color: Color transparent;
				layoutPolicy: TableLayout new;
				cellPositioning: #leftCenter;
				listDirection: #leftToRight;
				hResizing: #shrinkWrap;
				vResizing: #spaceFill.
			morph addMorphBack: (LineMorph from: 0 @ 0 to: 20 @ 0 color: Color black width: 1) 	makeForwardArrow.
			self children
				do: [ :each | morph addMorphBack: (each morphicShapeSeen: aSet depth: anInteger - 1) ]
				separatedBy: [ morph addMorphBack: (LineMorph from: 0 @ 0 to: 20 @ 0 color: Color black width: 1) makeForwardArrow ].
			morph addMorphBack: ((LineMorph from: 0 @ 0 to: 20 @ 0 color: Color black width: 1) 
				"vResizing: #spaceFill;"
				makeForwardArrow;
				yourself).
			morph ]! !

Object subclass: #PPBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PetitGui-Core'!

!PPBrowser class methodsFor: 'instance-creation' stamp: 'lr 11/6/2009 16:32'!
open
	^ self new open! !

!PPBrowser methodsFor: 'browse-parts' stamp: 'lr 11/10/2009 22:56'!
browseExampleOn: aBrowser
	aBrowser text
		title: 'Example';
		display: [ :parsers | (self productionFor: parsers) example ]! !

!PPBrowser methodsFor: 'browse-parts' stamp: 'lr 11/10/2009 22:56'!
browseFirstOn: aBrowser
	aBrowser list
		title: 'First';
		format: [ :parser | parser displayName ];
		display: [ :parsers | (self productionFor: parsers) firstSet ]! !

!PPBrowser methodsFor: 'browse-parts' stamp: 'lr 11/10/2009 22:56'!
browseFollowOn: aBrowser
	aBrowser list
		title: 'Follow';
		format: [ :parser | parser displayName ];
		display: [ :parsers | (self productionFor: parsers) followSet ]! !

!PPBrowser methodsFor: 'browse-parts' stamp: 'lr 11/10/2009 22:55'!
browseGraphOn: aBrowser
	aBrowser morph
		title: 'Graph';
		display: [ :parsers |
			| morph |
			morph := ScrollPane new.
			morph scroller addMorph: (self productionFor: parsers) morphicShape.
			morph ]! !

!PPBrowser methodsFor: 'browse' stamp: 'lr 11/9/2009 19:27'!
browseOn: aBrowser
	aBrowser title: 'PetitParser Browser'; color: Color purple lighter lighter.
	aBrowser column: #parsers; column: #production span: 3.
	
	aBrowser showOn: #parsers; using: [ 
		self browseParserOn: aBrowser ].
	aBrowser showOn: #production; from: #parsers -> #selectionPath; using: [
		self browseSourceOn: aBrowser.
		self browseTestOn: aBrowser.
		self browseGraphOn: aBrowser.
		self browseExampleOn: aBrowser.
		self browseFirstOn: aBrowser.
		self browseFollowOn: aBrowser ]! !

!PPBrowser methodsFor: 'browse-parts' stamp: 'lr 11/10/2009 22:47'!
browseParserOn: aBrowser
	aBrowser tree
		format: [ :value | value asString ];
		children: [ :value | self childrenOf: value ];
		act: [ :node | 
			StandardToolSet
				browse: (self classFor: node selectionPath)
				selector: (self selectorFor: node selectionPath) ]
			on: $b entitled: 'browse (b)';
		act: [ :node :parsers | 
			| class selector |
			class := self classFor: node selectionPath.
			selector := self selectorFor: node selectionPath.
			selector = #start
				ifTrue: [ class removeFromSystem ]
				ifFalse: [
					(class allInstVarNames includes: selector asString)
						ifTrue: [ class removeInstVarName: selector asString ].
					class removeSelector: selector ].
			aBrowser entity: self model.
			((aBrowser paneNamed: #parsers)
				port: #selection) 
					value: class ]
			on: $x entitled: 'remove (x)'! !

!PPBrowser methodsFor: 'browse-parts' stamp: 'lr 11/10/2009 22:33'!
browseSourceOn: aBrowser
	aBrowser text
		title: 'Source';
		display: [ :parsers | 
			(self classFor: parsers)
				sourceCodeAt: (self selectorFor: parsers) ];
		forSmalltalk: [ :parsers | self classFor: parsers ];
		act: [ :node :parsers | 
			| class selector |
			class := self classFor: parsers.
			selector := class compile: node text asString.
			(selector numArgs = 0 and: [ (class allInstVarNames includes: selector asString) not ])
				ifTrue: [ class addInstVarName: selector asString ].
			aBrowser entity: self model.
			((aBrowser paneNamed: #parsers) 
				port: #selection)
				value: selector ]
		on: $s entitled: 'accept (s)'
		! !

!PPBrowser methodsFor: 'browse-parts' stamp: 'lr 11/10/2009 22:53'!
browseTestOn: aBrowser
	| browser contents |
	browser := aBrowser table.
	browser title: 'Test'; row: #input; row: #output.
	
	contents := String new.
	browser showOn: #input; using: [
		browser text
			display: [ :parsers | contents ];
			update: #selection on: $s entitled: 'parse (s)' with: [ :presentation | 
				contents := presentation text copy ] ].
	browser showOn: #output; from: #outer -> #entity; from: #input; using: [
		browser text
			useExplicitNotNil;
			when: [ :parsers | parsers notNil ];
			display: [ :parsers | 
				(self productionFor: parsers)
					parse: contents asParserStream ] ]! !

!PPBrowser methodsFor: 'querying' stamp: 'lr 11/10/2009 22:34'!
childrenOf: aBehavior
	| variables |
	aBehavior isBehavior
		ifFalse: [ ^ Array new ].
	variables := ((aBehavior allInstVarNames
		copyWithoutAll: self root allInstVarNames)
			collect: [ :each | each asSymbol ])
				select: [ :each | aBehavior includesSelector: each ].
	^ OrderedCollection new
		addAll: (aBehavior subclasses asSortedCollection: [ :a :b | a name < b name ]);
		addAll: (variables asSortedCollection);
		yourself! !

!PPBrowser methodsFor: 'querying' stamp: 'lr 11/10/2009 22:30'!
classFor: aSelectionPath
	aSelectionPath reverseDo: [ :each |
		each isBehavior
			ifTrue: [ ^ each ] ].
	^ self root! !

!PPBrowser methodsFor: 'accessing' stamp: 'lr 11/10/2009 22:28'!
model
	^ self childrenOf: self root! !

!PPBrowser methodsFor: 'public' stamp: 'lr 11/10/2009 22:00'!
open
	| browser |
	browser := GLMTableLayoutBrowser new.
	self browseOn: browser.
	browser openOn: self model! !

!PPBrowser methodsFor: 'querying' stamp: 'lr 11/10/2009 22:51'!
parserFor: aSelectionPath
	aSelectionPath reverseDo: [ :each |
		each isBehavior
			ifTrue: [ ^ each ] ].
	^ self root! !

!PPBrowser methodsFor: 'querying' stamp: 'lr 11/10/2009 22:57'!
productionFor: aSelectionPath
	| parser selector |
	parser := (self classFor: aSelectionPath) new.
	selector := self selectorFor: aSelectionPath.
	^ selector = #start 
		ifFalse: [ parser instVarNamed: selector ]
		ifTrue: [ parser ]! !

!PPBrowser methodsFor: 'accessing' stamp: 'lr 11/10/2009 22:28'!
root
	^ PPCompositeParser! !

!PPBrowser methodsFor: 'querying' stamp: 'lr 11/10/2009 22:34'!
selectorFor: aSelectionPath
	^ (aSelectionPath isEmpty or: [ aSelectionPath last isBehavior ])
		ifFalse: [ aSelectionPath last ]
		ifTrue: [ #start ]! !

!PPFlattenParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/9/2009 14:28'!
exampleOn: aStream
	super exampleOn: aStream.
	aStream space! !

!PPPredicateParser methodsFor: '*petitgui-mondrian' stamp: 'lr 11/7/2009 14:21'!
displayName
	^ predicateMessage! !

!PPPredicateParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/9/2009 14:34'!
exampleOn: aStream
	| valid normal |
	valid := Character allCharacters
		select: [ :char | predicate value: char ].
	normal := valid
		select: [ :char | char asInteger < 127 and: [ char isAlphaNumeric ] ].
	aStream nextPut: (normal isEmpty
		ifTrue: [ valid atRandom ]
		ifFalse: [ normal atRandom ])! !

!PPFailingParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/6/2009 18:43'!
displayColor
	^ Color red! !

!PPFailingParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/6/2009 18:43'!
displayName
	^ message! !

!PPDelegateParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/9/2009 14:27'!
exampleOn: aStream
	parser exampleOn: aStream! !

!PPDelegateParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/7/2009 14:58'!
morphicShapeSeen: aSet depth: anInteger
	aSet add: self.
	^ parser morphicShapeSeen: aSet depth: anInteger! !

!PPRepeatingParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/9/2009 14:42'!
exampleOn: aStream
	(min to: (max min: min + 5)) atRandom
		timesRepeat: [ super exampleOn: aStream ]! !

!PPRepeatingParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/7/2009 14:56'!
morphicShapeSeen: aSet depth: anInteger
	| morph |
	^ (anInteger < 1 or: [ aSet includes: self ])
		ifTrue: [ super morphicShapeSeen: aSet depth: anInteger ]
		ifFalse: [
			aSet add: self.
			morph := RectangleMorph new.
			morph 
				borderWidth: 1;
				color: Color transparent;
				layoutPolicy: TableLayout new;
				listDirection: #leftToRight;
				wrapCentering: #center;
				hResizing: #shrinkWrap;
				vResizing: #shrinkWrap;
				layoutInset: 0 @ 5.
			morph addMorphBack: (LineMorph from: 0 @ 0 to: 20 @ 0 color: Color black width: 1) makeForwardArrow.
			morph addMorphBack: (parser morphicShapeSeen: aSet depth: anInteger - 1).
			morph addMorphBack: (LineMorph from: 0 @ 0 to: 20 @ 0 color: Color black width: 1) makeForwardArrow.
			morph ]! !

!PPLiteralObjectParser methodsFor: '*petitgui-accessing' stamp: 'lr 11/9/2009 14:25'!
exampleOn: aStream
	aStream nextPut: literal! !
